#ifndef __EMBOSS_STRING_VIEW_H__
#define __EMBOSS_STRING_VIEW_H__

#include <View.h>
#include <String.h>

class EmbossStringView : public BView
{
public:

	EmbossStringView(const BRect &bounds,
					 const char *name,
					 const char *text,
					 uint32 resizeFlags = B_FOLLOW_LEFT | B_FOLLOW_TOP,
					 uint32 flags = B_WILL_DRAW);

	virtual ~EmbossStringView();

	// BView interface
	virtual void	Draw(BRect bounds);
	virtual void	ResizeToPreferred();
	virtual void	GetPreferredSize(float *width, float *height);

	// BStringView-style interface
	void			SetText(const char *text); 
	const char *	Text() const; 
	void			SetAlignment(alignment flag); 
	alignment		Alignment() const;

private:

	BString			mText;
	alignment		mAlign;
};

#endif // __EMBOSS_STRING_VIEW_H__
