#ifndef __FRAMEWORK_BITMAP_H__
#define __FRAMEWORK_BITMAP_H__

#include <Window.h>
#include <View.h>
#include <Bitmap.h>

#include "frmwrk.h"

// view ///////////////////////////////////////////////////////////////////

class FlipView : public BView
{
	friend				class FrmBmpWindow; 

	struct BufferRecord
	{
		BBitmap	*		bitmap;
		sem_id			writeLock;
		bool			unlockAtActivate;
		
		BufferRecord() :
			bitmap(NULL),
			writeLock(B_ERROR)
		{ }
	}
					  *	mRing;
	int32				mRingSize;
	int32				mFlipSelector;

	bool				mMinimized;

	void				DestroyRingLocks();

public:

	FlipView(FrameworkParams &params, status_t &error, const char * &error_text);
	~FlipView();

	virtual void		MessageReceived(BMessage *message);
	virtual void		WindowActivated(bool active);
	virtual void		Draw(BRect updateRect);
};

// window /////////////////////////////////////////////////////////////////

class FrmBmpWindow : public BWindow, public Framework
{
	FlipView *			mView;

	uint32				mDrawSelector;

public:

	FrmBmpWindow(FrameworkParams &params, status_t &error, const char * &error_text);
	~FrmBmpWindow();

	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(Buffer &);
	virtual void		frame_close();
};

#endif // __FRAMEWORK_BITMAP_H__
