#ifndef __FRAMEWORK_WINDOW_SCREEN_H__
#define __FRAMEWORK_WINDOW_SCREEN_H__

#include <OS.h>
#include <Locker.h>
#include <WindowScreen.h>
#include <Screen.h>

#include "frmwrk.h"

// window ////////////////////////////////////////////////////////////////////////////

class FrmWindowScreen : public BWindowScreen, public Framework
{
	BLocker				mDrawLock;
	BScreen *			mBScreen;

	int					mFlipSelector;
	int					mDrawSelector;

	struct BufferRecord
	{
		uint8 *			bits;
		sem_id			writeLock;
		bool			unlockAtConnect;

		BufferRecord() :
			bits(NULL),
			writeLock(B_ERROR)
		{ }
	}
					  * mRing;

	struct BufferBitsInfo
	{
		int32			bytesPerRow; 
		uint32			bitsPerPixel;
	}
						mBitsInfo;
	struct PointInt
	{
		int32			x;
		int32			y;
	}
						mFramePos,
						mFrameSize,
						mScreenSize;

	volatile bool		mConnected;

	FrameworkParams &	mParams;
	status_t &			mError;
	const char * &		mErrorText;

	bigtime_t			mFlipTime;

	static uint32		MatchScreenSpace(BPoint &frameBounds, color_space color);

public:

	FrmWindowScreen(FrameworkParams &params, status_t &error, const char * &error_text);
	~FrmWindowScreen();

	virtual void		MessageReceived(BMessage *message); 
	virtual void		ScreenConnected(bool connected);
	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(Buffer &);
	virtual void	 	frame_close();
};

#endif // __FRAMEWORK_WINDOW_SCREEN_H__
