#ifndef __SETUPWINDOW_H__
#define __SETUPWINDOW_H__

#include <Window.h>
#include <List.h>

#include "app_params.h"

#include "frmHelper.h"

// window /////////////////////////////////////////////////////////////////

class SetupWindow : public BWindow, public Lifespan
{
	AppParams &			mParams;
	BList				mPixFormats;

	BRadioButton *		mDesktopPixFormat;

	// enable all radio buttons within the specified view
	void				EnableRadioButtons(const char *groupViewName) const;
	// disable all radio buttons within the specified view, optionally set one of those buttons to 'on' 
	void				DisableRadioButtons(const char *groupViewName, BRadioButton *buttonOn = NULL) const;

public:

	SetupWindow(AppParams &);
	~SetupWindow();

	virtual void 		MessageReceived(BMessage *message);
	virtual bool		QuitRequested();
};

#endif // __SETUPWINDOW_H__
