#ifndef __RENDSPAN__
#define __RENDSPAN__

#include "rendBaseTypes.h"

void Span4_nop(const float (&)[4],
			   const float (&)[4]);

void Span6_nop(const float (&)[6],
			   const float (&)[6]);

void Span8_nop(const float (&)[8],
			   const float (&)[8]);

// Vertex4UV spanners /////////////////////////////////////////////////////////////

void Span4UV_cpy_ARGB1555_nearest(const Vertex4UV &,
								  const Vertex4UV &);

void Span4UV_cpy_ARGB8888_nearest(const Vertex4UV &,
								  const Vertex4UV &);

void Span4UV_cpy_RGB565_nearest(const Vertex4UV &,
								const Vertex4UV &);

void Span4UV_cpy_RGB888_nearest(const Vertex4UV &,
								const Vertex4UV &);

void Span4UV_cpy_ARGB1555_linear(const Vertex4UV &,
								 const Vertex4UV &);

void Span4UV_cpy_ARGB8888_linear(const Vertex4UV &,
								 const Vertex4UV &);

void Span4UV_cpy_RGB565_linear(const Vertex4UV &,
							   const Vertex4UV &);

void Span4UV_cpy_RGB888_linear(const Vertex4UV &,
							   const Vertex4UV &);

void Span4UV_cpy_ARGB8888_nearest_nearest(const Vertex4UV &,
										  const Vertex4UV &);

void Span4UV_cpy_ARGB1555_nearest_nearest(const Vertex4UV &,
										  const Vertex4UV &);

void Span4UV_cpy_RGB888_nearest_nearest(const Vertex4UV &,
										const Vertex4UV &);

void Span4UV_cpy_RGB565_nearest_nearest(const Vertex4UV &,
										const Vertex4UV &);

void Span4UV_cpy_ARGB8888_nearest_linear(const Vertex4UV &,
										 const Vertex4UV &);

void Span4UV_cpy_ARGB1555_nearest_linear(const Vertex4UV &,
										 const Vertex4UV &);

void Span4UV_cpy_RGB888_nearest_linear(const Vertex4UV &,
									   const Vertex4UV &);

void Span4UV_cpy_RGB565_nearest_linear(const Vertex4UV &,
									   const Vertex4UV &);

void Span4UV_cpy_DA16_nearest(const Vertex4UV &,
							  const Vertex4UV &);

void Span4UV_cpy_DA12_nearest(const Vertex4UV &,
							  const Vertex4UV &);

void Span4UV_cpy_DA8_nearest(const Vertex4UV &,
							 const Vertex4UV &);

void Span4UV_cpy_DA16_linear(const Vertex4UV &,
							 const Vertex4UV &);

void Span4UV_cpy_DA12_linear(const Vertex4UV &,
							 const Vertex4UV &);

void Span4UV_cpy_DA8_linear(const Vertex4UV &,
							const Vertex4UV &);

void Span4UV_cpy_DA16_nearest_nearest(const Vertex4UV &,
									  const Vertex4UV &);

void Span4UV_cpy_DA12_nearest_nearest(const Vertex4UV &,
									  const Vertex4UV &);

void Span4UV_cpy_DA8_nearest_nearest(const Vertex4UV &,
									 const Vertex4UV &);

void Span4UV_cpy_DA16_nearest_linear(const Vertex4UV &,
									 const Vertex4UV &);

void Span4UV_cpy_DA12_nearest_linear(const Vertex4UV &,
									 const Vertex4UV &);

void Span4UV_cpy_DA8_nearest_linear(const Vertex4UV &,
									const Vertex4UV &);

// Vertex4ARGB spanners ///////////////////////////////////////////////////////////

void Span4ARGB_cpy_ARGB8888(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_cpy_ARGB1555(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_cpy_RGB888(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_cpy_RGB565(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_add_ARGB8888(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_add_ARGB1555(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_add_RGB888(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_add_RGB565(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_mod_ARGB8888(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_mod_ARGB1555(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_mod_RGB888(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_mod_RGB565(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_dot_ARGB8888(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_dot_ARGB1555(const Vertex4ARGB &,
							const Vertex4ARGB &);

void Span4ARGB_dot_RGB888(const Vertex4ARGB &,
						  const Vertex4ARGB &);

void Span4ARGB_dot_RGB565(const Vertex4ARGB &,
						  const Vertex4ARGB &);

// Vertex4 spanners ///////////////////////////////////////////////////////////////

void Span4_cpy_ARGB1555_ARGB1555(const Vertex4 &,
								 const Vertex4 &);

void Span4_cpy_ARGB1555_ARGB8888(const Vertex4 &,
								 const Vertex4 &);

void Span4_cpy_ARGB1555_RGB565(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_ARGB1555_RGB888(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_ARGB8888_ARGB1555(const Vertex4 &,
								 const Vertex4 &);

void Span4_cpy_ARGB8888_ARGB8888(const Vertex4 &,
								 const Vertex4 &);

void Span4_cpy_ARGB8888_RGB565(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_ARGB8888_RGB888(const Vertex4 &,
							   const Vertex4 &);
		
void Span4_cpy_RGB565_ARGB1555(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_RGB565_ARGB8888(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_RGB565_RGB565(const Vertex4 &,
							 const Vertex4 &);

void Span4_cpy_RGB565_RGB888(const Vertex4 &,
							 const Vertex4 &);

void Span4_cpy_RGB888_ARGB1555(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_RGB888_ARGB8888(const Vertex4 &,
							   const Vertex4 &);

void Span4_cpy_RGB888_RGB565(const Vertex4 &,
							 const Vertex4 &);

void Span4_cpy_RGB888_RGB888(const Vertex4 &,
							 const Vertex4 &);

#endif // __RENDSPAN__
